{***************************************************************************}
{ TAdvOfficeSelectors demo                                                  }
{ for Delphi & C++Builder                                                   }
{                                                                           }
{ written by TMS Software                                                   }
{            copyright  2006                                               }
{            Email : info@tmssoftware.com                                   }
{            Web : http://www.tmssoftware.com                               }
{                                                                           }
{ The source code is given as is. The author is not responsible             }
{ for any possible damage done due to the use of this code.                 }
{ The component can be freely used in any application. The complete         }
{ source code remains property of the author and may not be distributed,    }
{ published, given or sold in any form as such. No parts of the source      }
{ code can be included in any other component or application without        }
{ written authorization of the author.                                      }
{***************************************************************************}

unit UGraphicsEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, AdvOfficeComboBox, AdvGlowButton,
  AdvOfficeSelectors, ExtActns, ActnList, StdActns, ComCtrls,
  Menus, AdvStyleIF, ExtCtrls, ImgList;

type
  TForm1 = class(TForm)
    ActionList1: TActionList;
    RichEditBold1: TRichEditBold;
    RichEditItalic1: TRichEditItalic;
    RichEditUnderline1: TRichEditUnderline;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    ImageList1: TImageList;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    AdvOfficePenWidthSelector1: TAdvOfficePenWidthSelector;
    AdvOfficePenStyleSelector1: TAdvOfficePenStyleSelector;
    AdvOfficeColorSelector3: TAdvOfficeColorSelector;
    AdvOfficeBrushStyleSelector1: TAdvOfficeBrushStyleSelector;
    AdvOfficeColorSelector4: TAdvOfficeColorSelector;
    AdvOfficeColorSelector5: TAdvOfficeColorSelector;
    AdvOfficeTableSelector2: TAdvOfficeTableSelector;
    AdvOfficeShadowSelector2: TAdvOfficeShadowSelector;
    AdvOfficeTableBorderSelector2: TAdvOfficeTableBorderSelector;
    AdvOfficeToolSelector2: TAdvOfficeToolSelector;
    RichEdit1: TRichEdit;
    PaintBox1: TPaintBox;
    TabSheet3: TTabSheet;
    AdvOfficeFontSelector2: TAdvOfficeFontSelector;
    AdvOfficeFontSizeSelector2: TAdvOfficeFontSizeSelector;
    AdvOfficeColorSelector9: TAdvOfficeColorSelector;
    AdvOfficeColorSelector10: TAdvOfficeColorSelector;
    AdvOfficeCharacterSelector2: TAdvOfficeCharacterSelector;
    AdvOfficeToolSelector1: TAdvOfficeToolSelector;
    AdvOfficeToolSelector3: TAdvOfficeToolSelector;
    MainMenu1: TMainMenu;
    Style1: TMenuItem;
    Office2007Luna1: TMenuItem;
    Office2007Obsidian1: TMenuItem;
    Office2003Blue1: TMenuItem;
    Office2003Olive1: TMenuItem;
    Office2003Silver1: TMenuItem;
    VisualStudio20051: TMenuItem;
    TabSheet4: TTabSheet;
    AdvOfficeScrollSelector1: TAdvOfficeScrollSelector;
    ImageList2: TImageList;
    procedure AdvOfficeColorSelector1SelectColor(Sender: TObject;
      AColor: TColor);
    procedure RichEdit1SelectionChange(Sender: TObject);
    procedure AdvOfficeFontSelector1Select(Sender: TObject);
    procedure AdvOfficeFontSizeSelector1Select(Sender: TObject);
    procedure AdvOfficeColorSelector2SelectColor(Sender: TObject;
      AColor: TColor);
    procedure file1Click(Sender: TObject);
    procedure AdvOfficeCharacterSelector1Select(Sender: TObject);
    procedure AdvOfficeCharacterSelector1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure AdvOfficePenStyleSelector1Select(Sender: TObject; Index: Integer;
      Item: TAdvSelectorItem);
    procedure AdvOfficePenWidthSelector1Select(Sender: TObject; Index: Integer;
      Item: TAdvSelectorItem);
    procedure AdvOfficeBrushStyleSelector1SelectBrushStyle(Sender: TObject;
      AStyle: TBrushStyle);
    procedure AdvOfficeColorSelector3SelectColor(Sender: TObject;
      AColor: TColor);
    procedure AdvOfficeColorSelector4SelectColor(Sender: TObject;
      AColor: TColor);
    procedure AdvOfficeColorSelector5SelectColor(Sender: TObject;
      AColor: TColor);
    procedure AdvOfficeToolSelector1DrawTool(Sender: TObject; Canvas: TCanvas;
      ItemIndex: Integer; R: TRect);
    procedure AdvOfficeToolSelector3Select(Sender: TObject; Index: Integer;
      Item: TAdvSelectorItem);
    procedure Office2007Luna1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    APen: TPen;
    ABrush: TBrush;
    procedure SetStyle(AStyle: TTMSStyle);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.AdvOfficeBrushStyleSelector1SelectBrushStyle(Sender: TObject;
  AStyle: TBrushStyle);
begin
  PaintBox1.Repaint;
end;

procedure TForm1.AdvOfficeCharacterSelector1Click(Sender: TObject);
begin
  RichEdit1.SelText := AdvOfficeCharacterSelector2.SelectedChar;
end;

procedure TForm1.AdvOfficeCharacterSelector1Select(Sender: TObject);
begin
  RichEdit1.SelText := AdvOfficeCharacterSelector2.SelectedChar;
end;

procedure TForm1.AdvOfficeColorSelector1SelectColor(Sender: TObject;
  AColor: TColor);
begin
  RichEdit1.SelAttributes.Color := AColor;
end;

procedure TForm1.AdvOfficeColorSelector2SelectColor(Sender: TObject;
  AColor: TColor);
begin
  RichEdit1.Color := AColor;
end;

procedure TForm1.AdvOfficeColorSelector3SelectColor(Sender: TObject;
  AColor: TColor);
begin
  AdvOfficePenStyleSelector1.PenColor := AColor;
  PaintBox1.Repaint;
end;

procedure TForm1.AdvOfficeColorSelector4SelectColor(Sender: TObject;
  AColor: TColor);
begin
  AdvOfficeBrushStyleSelector1.BrushColor := AdvOfficeColorSelector4.SelectedColor;
  PaintBox1.Repaint;
end;

procedure TForm1.AdvOfficeColorSelector5SelectColor(Sender: TObject;
  AColor: TColor);
begin
  PaintBox1.Repaint;
end;

procedure TForm1.AdvOfficeFontSelector1Select(Sender: TObject);
begin
  RichEdit1.SelAttributes.Name := AdvOfficeFontSelector2.Text;
end;

procedure TForm1.AdvOfficeFontSizeSelector1Select(Sender: TObject);
begin
  RichEdit1.SelAttributes.Size := StrToInt(AdvOfficeFontSizeSelector2.Text);
end;

procedure TForm1.AdvOfficePenStyleSelector1Select(Sender: TObject;
  Index: Integer; Item: TAdvSelectorItem);
begin
  PaintBox1.Repaint;
end;

procedure TForm1.AdvOfficePenWidthSelector1Select(Sender: TObject;
  Index: Integer; Item: TAdvSelectorItem);
begin
  PaintBox1.Repaint;
end;

procedure TForm1.AdvOfficeToolSelector1DrawTool(Sender: TObject;
  Canvas: TCanvas; ItemIndex: Integer; R: TRect);
var
  ar: array[0..2] of TPoint;

begin
  if ItemIndex >= 0 then
  begin
    Canvas.Brush.Color := AdvOfficeToolSelector1.Tools[ItemIndex].BackGroundColor;
    Canvas.Pen.Color := clBlack;
    InflateRect(r, -2, -2);

    case ItemIndex of
    0: Canvas.Rectangle(R);
    1: Canvas.Ellipse(R);
    2: begin
         ar[0] := Point(R.Left + ((R.Right - R.Left) shr 1), R.Top);
         ar[1] := Point(R.Right, R.Bottom);
         ar[2] := Point(R.Left, R.Bottom);
         Canvas.Polygon(ar);
       end;
    3: begin
         ar[0] := Point(R.Left, R.Top);
         ar[1] := Point(R.Right, R.Bottom);
         ar[2] := Point(R.Left, R.Bottom);
         Canvas.Polygon(ar);
       end;
    4: begin
         ar[0] := Point(R.Right, R.Top);
         ar[1] := Point(R.Right, R.Bottom);
         ar[2] := Point(R.Left, R.Bottom);
         Canvas.Polygon(ar);
       end;
    5: begin
         InflateRect(R,0,-3);
         Canvas.Ellipse(R);
       end;
    end;
  end;
end;

procedure TForm1.AdvOfficeToolSelector3Select(Sender: TObject; Index: Integer;
  Item: TAdvSelectorItem);
begin
  if Index <> -1 then 
    AdvOfficeToolSelector3.Caption := Item.Caption;
end;

procedure TForm1.file1Click(Sender: TObject);
begin
{
  case (Sender as TMenuItem).Tag of
  0:begin
      AdvGlowMenuButton1.Caption := 'Office 2007 Luna';
      AdvFormStyler1.Style := tsOffice2007Luna;
    end;
  1:begin
      AdvGlowMenuButton1.Caption := 'Office 2007 Obsidian';
      AdvFormStyler1.Style := tsOffice2007Obsidian;
    end;
  2:begin
      AdvGlowMenuButton1.Caption := 'Office 2003 Blue';
      AdvFormStyler1.Style := tsOffice2003Blue;
    end;
  3:begin
      AdvGlowMenuButton1.Caption := 'Office 2003 Olive';
      AdvFormStyler1.Style := tsOffice2003Olive;
    end;
  4:begin
      AdvGlowMenuButton1.Caption := 'Office 2003 Silver';
      AdvFormStyler1.Style := tsOffice2003Silver;
    end;
  5:begin
      AdvGlowMenuButton1.Caption := 'Visual Studio 2005';
      AdvFormStyler1.Style := tsWhidbey;
    end;
  end;
}
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  ATI: TAdvSelectorItem;
begin
  APen := TPen.Create;
  ABrush := TBrush.Create;



  AdvOfficeToolSelector1.OwnerDrawToolWidth := 32;
  AdvOfficeToolSelector1.OwnerDrawToolHeight := 32;
  AdvOfficeToolSelector1.ButtonsPerRow := 1;
  with AdvOfficeToolSelector1.Tools do
  begin
    Clear;
    ATI := Add;
    ATI.Hint := 'Rectangle';
    ATI.BackGroundColor := clRed;
    ATI := Add;
    ATI.Hint := 'Circle';
    ATI.BackGroundColor := clLime;
    ATI := Add;
    ATI.Hint := 'Triangle';
    ATI.BackGroundColor := clYellow;
    ATI := Add;
    ATI.Hint := 'Left triangle';
    ATI.BackGroundColor := clSkyblue;
    ATI := Add;
    ATI.Hint := 'Right triangle';
    ATI.BackGroundColor := clTeal;
    ATI := Add;
    ATI.Hint := 'Ellipse';
    ATI.BackGroundColor := $00C080FF;
  end;

  AdvOfficeToolSelector3.ShowCaption := true;
  AdvOfficeToolSelector3.DropDownButton := true;
  with AdvOfficeToolSelector3.Tools do
  begin
    Clear;
    Add.Caption := 'BMW';
    Add.Caption := 'Mercedes';
    Add.Caption := 'Audi';
    Add.Caption := 'Porsche';
    Add.Caption := 'Ferrari';
  end;

  SetStyle(tsOffice2007Luna);

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  APen.Free;
  ABrush.Free;
end;

procedure TForm1.Office2007Luna1Click(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := true;
  case (Sender as TMenuItem).Tag of
  0:begin
      SetStyle(tsOffice2007Luna);
    end;
  1:begin
      SetStyle(tsOffice2007Obsidian);
    end;
  2:begin
      SetStyle(tsOffice2003Blue);
    end;
  3:begin
      SetStyle(tsOffice2003Olive);
    end;
  4:begin
      SetStyle(tsOffice2003Silver);
    end;
  5:begin
      SetStyle(tsWhidbey);
    end;
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  r: TRect;
begin

  PaintBox1.Canvas.Brush.Style := AdvOfficeBrushStyleSelector1.SelectedBrushStyle;
  PaintBox1.Canvas.Brush.Color := AdvOfficeColorSelector4.SelectedColor;

  SetBkMode(Canvas.Handle, TRANSPARENT);
  SetBkColor(PaintBox1.Canvas.Handle, ColorToRGB(AdvOfficeColorSelector5.SelectedColor));

  r := Rect(20,20,200,200);
  PaintBox1.Canvas.FillRect(r);

  Canvas.Brush.Style := bsClear;

  PaintBox1.Canvas.Pen.Color := AdvOfficeColorSelector3.SelectedColor;
  PaintBox1.Canvas.Pen.Width := AdvOfficePenWidthSelector1.SelectedPenWidth;
  PaintBox1.Canvas.Pen.Style := AdvOfficePenStyleSelector1.SelectedPenStyle;

  PaintBox1.Canvas.Rectangle(r);

end;

procedure TForm1.RichEdit1SelectionChange(Sender: TObject);
begin
  AdvOfficeColorSelector9.SelectedColor := RichEdit1.SelAttributes.Color;
  AdvOfficeFontSelector2.Text := RichEdit1.SelAttributes.Name;
  AdvOfficeFontSizeSelector2.Text := IntToStr(RichEdit1.SelAttributes.Size);
end;

procedure TForm1.SetStyle(AStyle: TTMSStyle);
var
  i: integer;
  tmsif: ITMSStyle;
begin
  for i := 0 to ComponentCount - 1 do
  begin
    if Components[i].GetInterface(ITMSStyle, tmsif) then
      tmsif.SetComponentStyle(AStyle);
  end;

end;

end.